HORIZON HASKELLDocslts/ghc-9.10.xc74966e2026-09-27Search names, modules, packages, or :: a typeCtrl K

GHC 9.10.3 · lts/ghc-9.10.x · c74966e · 2026-09-27

Modulehttp-conduit-2.3.9.1Haskell2010

Network.HTTP.Client.Conduit

A new, experimental API to replace Network.HTTP.Conduit.

For most users, Network.HTTP.Simple is probably a better choice. For more information, see:

https://haskell-lang.org/library/http-client

For more information on using this module, please be sure to read the documentation in the Network.HTTP.Client module.

  • 17 types
  • 1 class
  • 115 values

Conduit-specific interface

5 declarations

Manager helpers

3 declarations

General HTTP client interface

122 declarations
datadata Proxy
#

Define a HTTP proxy, consisting of a hostname and port number.

Constructors

Instances4Eq, Ord, Read, Show
  • Eq ProxyDefined in http-client-0.7.19 · Network.HTTP.Client.Types
  • Ord ProxyDefined in http-client-0.7.19 · Network.HTTP.Client.Types
  • Read ProxyDefined in http-client-0.7.19 · Network.HTTP.Client.Types
  • Show ProxyDefined in http-client-0.7.19 · Network.HTTP.Client.Types
datadata RequestBody
#

When using one of the RequestBodyStream / RequestBodyStreamChunked constructors, you must ensure that the GivesPopper can be called multiple times. Usually this is not a problem.

The RequestBodyStreamChunked will send a chunked request body. Note that not all servers support this. Only use RequestBodyStreamChunked if you know the server you're sending to supports chunked request bodies.

Since 0.1.0

Constructors

Instances3IsString, Semigroup, Monoid
datadata Request
#

All information on how to connect to a host and what should be sent in the HTTP request.

If you simply wish to download from a URL, see parseRequest.

The constructor for this data type is not exposed. Instead, you should use either the defaultRequest value, or parseRequest to construct from a URL, and then use the records below to make modifications. This approach allows http-client to add configuration options without breaking backwards compatibility.

For example, to construct a POST request, you could do something like:

initReq <- parseRequest "http://www.example.com/path"
let req = initReq
            { method = "POST"
            }

For more information, please see http://www.yesodweb.com/book/settings-types.

Since 0.1.0

Instances2Show, IsString
valuehost :: Request -> ByteString
#

Requested host name, used for both the IP address to connect to and the host request header.

This is in URI format, with raw IPv6 addresses enclosed in square brackets. Use strippedHostName when making network connections.

Since 0.1.0

valueport :: Request -> Int
#

The port to connect to. Also used for generating the host request header.

Since 0.1.0

Custom HTTP request headers

The Content-Length and Transfer-Encoding headers are set automatically by this module, and shall not be added to requestHeaders.

If not provided by the user, Host will automatically be set based on the host and port fields.

Moreover, the Accept-Encoding header is set implicitly to gzip for convenience by default. This behaviour can be overridden if needed, by setting the header explicitly to a different value. In order to omit the Accept-Header altogether, set it to the empty string "". If you need an empty Accept-Header (i.e. requesting the identity encoding), set it to a non-empty white-space string, e.g. " ". See RFC 2616 section 14.3 for details about the semantics of the Accept-Header field. If you request a content-encoding not supported by this module, you will have to decode it yourself (see also the decompress field).

Note: Multiple header fields with the same field-name will result in multiple header fields being sent and therefore it's the responsibility of the client code to ensure that the rules from RFC 2616 section 4.2 are honoured.

Since 0.1.0

valuedecompress :: Request -> ByteString -> Bool
#

Predicate to specify whether gzipped data should be decompressed on the fly (see alwaysDecompress and browserDecompress). Argument is the mime type. Default: browserDecompress.

Since 0.1.0

valueredirectCount :: Request -> Int
#

How many redirects to follow when getting a resource. 0 means follow no redirects. Default value: 10.

Since 0.1.0

Check the response immediately after receiving the status and headers. This can be useful for throwing exceptions on non-success status codes.

In previous versions of http-client, this went under the name checkStatus, but was renamed to avoid confusion about the new default behavior (doing nothing).

datadata Response body
#

A simple representation of the HTTP response.

Since 0.1.0

Instances4Functor, Foldable, Traversable, Show

Cookies set on the client after interacting with the server. If cookies have been disabled by setting cookieJar to Nothing, then this will always be empty.

Since 0.1.0

datadata Manager
#

Keeps track of open connections for keep-alive.

If possible, you should share a single Manager between multiple threads and requests.

Since 0.1.0

Instances1HasHttpManager

Total number of idle connection to keep open at a given time.

This limit helps deal with the case where you are making a large number of connections to different hosts. Without this limit, you could run out of file descriptors. Additionally, it can be set to zero to prevent reuse of any connections. Doing this is useful when the server your application is talking to sits behind a load balancer.

Default: 512

Since 0.3.7

Exceptions for which we should retry our request if we were reusing an already open connection. In the case of IOExceptions, for example, we assume that the connection was closed on the server and therefore open a new one.

Since 0.1.0

valuemanagerWrapException :: ManagerSettings -> forall a. Request -> IO a -> IO a
#

Action wrapped around all attempted Requests, usually used to wrap up exceptions in library-specific types.

Default: wrap all IOExceptions in the InternalException constructor.

datadata ResponseTimeout
#

How to deal with timing out on retrieval of response headers.

Instances2Eq, Show
datadata HttpExceptionContent
#

Constructors

Instances1Show
newtypenewtype CookieJar
#
Instances4Read, Show, Semigroup, Monoid
  • Read CookieJarDefined in http-client-0.7.19 · Network.HTTP.Client.Types
  • Show CookieJarDefined in http-client-0.7.19 · Network.HTTP.Client.Types
  • Semigroup CookieJarDefined in http-client-0.7.19 · Network.HTTP.Client.Types
  • Monoid CookieJarDefined in http-client-0.7.19 · Network.HTTP.Client.Types

    Since 1.9

valueparseRequest :: MonadThrow m => String -> m Request
#

Convert a URL into a Request.

This function defaults some of the values in Request, such as setting method to GET and requestHeaders to [].

Since this function uses MonadThrow, the return monad can be anything that is an instance of MonadThrow, such as IO or Maybe.

You can place the request method at the beginning of the URL separated by a space, e.g.:

parseRequest "POST http://httpbin.org/post"

Note that the request method must be provided as all capital letters.

A Request created by this function won't cause exceptions on non-2XX response status codes.

To create a request which throws on non-2XX status codes, see parseUrlThrow

Add a Basic Auth header (with the specified user name and password) to the given Request. Ignore error handling:

 applyBasicAuth "user" "pass" $ parseRequest_ url

NOTE: The function applyDigestAuth is provided by the http-client-tls package instead of this package due to extra dependencies. Please use that package if you need to use digest authentication.

Since 0.1.0

datadata HttpException
#

An exception which may be generated by this library

Constructors

Instances2Show, Exception
typetype GivesPopper a = NeedsPopper a -> IO a
#

A function which will provide a Popper to a NeedsPopper. This seemingly convoluted structure allows for creation of request bodies which allocate scarce resources in an exception safe manner.

Since 0.1.0

strippedHostName takes a URI host name, as extracted by Network.URI.regName, and strips square brackets around IPv6 addresses.

The result is suitable for passing to services such as name resolution (Network.Socket.getAddr).

@since

valuecomputeCookieString
  1. :: Request

    Input request

  2. -> CookieJar

    Current cookie jar

  3. -> UTCTime

    Value that should be used as "now"

  4. -> Bool

    Whether or not this request is coming from an "http" source (not javascript or anything like that)

  5. -> (ByteString, CookieJar)

    (Contents of a "Cookie" header, Updated cookie jar (last-access-time is updated))

#

This corresponds to the algorithm described in Section 5.4 "The Cookie Header"

valuedomainMatches
  1. :: ByteString

    Domain to test

  2. -> ByteString

    Domain from a cookie

  3. -> Bool
#

This corresponds to the subcomponent algorithm entitled "Domain Matching" detailed in section 5.1.3

valuegenerateCookie
  1. :: SetCookie

    The SetCookie we are encountering

  2. -> Request

    The request that originated the response that yielded the SetCookie

  3. -> UTCTime

    Value that should be used as "now"

  4. -> Bool

    Whether or not this request is coming from an "http" source (not javascript or anything like that)

  5. -> Maybe Cookie

    The optional output cookie

#

Turn a SetCookie into a Cookie, if it is valid

valueinsertCheckedCookie
  1. :: Cookie

    The SetCookie the cookie jar is receiving

  2. -> CookieJar

    Input cookie jar to modify

  3. -> Bool

    Whether or not this request is coming from an "http" source (not javascript or anything like that)

  4. -> CookieJar

    Updated (or not) cookie jar

#

Insert a cookie created by generateCookie into the cookie jar (or not if it shouldn't be allowed in)

valuereceiveSetCookie
  1. :: SetCookie

    The SetCookie the cookie jar is receiving

  2. -> Request

    The request that originated the response that yielded the SetCookie

  3. -> UTCTime

    Value that should be used as "now"

  4. -> Bool

    Whether or not this request is coming from an "http" source (not javascript or anything like that)

  5. -> CookieJar

    Input cookie jar to modify

  6. -> CookieJar

    Updated cookie jar

#

This corresponds to the algorithm described in Section 5.3 "Storage Model" This function consists of calling generateCookie followed by insertCheckedCookie. Use this function if you plan to do both in a row. generateCookie and insertCheckedCookie are only provided for more fine-grained control.

valuewithConnection :: Request -> Manager -> (Connection -> IO a) -> IO a
#

Perform an action using a Connection acquired from the given Manager.

You should use this only when you have to read and write interactively through the connection (e.g. connection by the WebSocket protocol).

The default proxy settings for a manager. In particular: if the http_proxy (or https_proxy) environment variable is set, use it. Otherwise, use the values in the Request.

Since 0.4.7

valuenoProxy :: ProxyOverride
#

Never connect using a proxy, regardless of the proxy value in the Request.

Since 0.4.7

valueproxyEnvironment
  1. :: Maybe Proxy

    fallback if no environment set

  2. -> ProxyOverride
#

Get the proxy settings from the default environment variable (http_proxy for insecure, https_proxy for secure). If no variable is set, then fall back to the given value. Nothing is equivalent to noProxy, Just is equivalent to useProxy.

Since 0.4.7

Send a file as the request body.

It is expected that the file size does not change between calling streamFile and making any requests using this request body.

Since 0.4.9

typetype Popper = IO ByteString
#

A function which generates successive chunks of a request body, provider a single empty bytestring when no more data is available.

Since 0.1.0

newtypenewtype ProxyOverride
#

How the HTTP proxy server settings should be discovered.

Since 0.4.7

valueequalCookie :: Cookie -> Cookie -> Bool
#

Instead of (==).

Since there was some confusion in the history of this library about how the Eq instance should work, it was removed for clarity, and replaced by equal and equiv. equal gives you equality of all fields of the Cookie record.

valueequivCookie :: Cookie -> Cookie -> Bool
#

Equality of name, domain, path only. This corresponds to step 11 of the algorithm described in Section 5.3 "Storage Model". See also: equal.

datadata HistoriedResponse body
#

A datatype holding information on redirected requests and the final response.

Since 0.4.1

Instances6Functor, Foldable, Traversable, Show, Generic, Rep

Lower-level conduit functions

3 declarations